window.Gleam.initSearch([{"doc":"sturnidae","title":"sturnidae","content":"# sturnidae\n\nBinding to Starling Bank&#39;s API.\n\n[![Package Version](https://img.shields.io/hexpm/v/sturnidae)](https://hex.pm/packages/sturnidae)\n[![Hex Docs](https://img.shields.io/badge/hex-docs-ffaff3)](https://hexdocs.pm/sturnidae/)\n\n```sh\ngleam add sturnidae\n```\n```gleam\nimport sturnidae\nimport gleam/httpc\n\npub fn main() {\n  // Build an API request\n  let request =\n    sturnidae.get_feed_items_request(\n      personal_access_token,\n      account_uid,\n      category_uid,\n      &quot;2015-01-01T01:01:00.000Z&quot;,\n    )\n\n  // Send it with a HTTP client such as gleam_httpc\n  let assert Ok(response) = |&gt; httpc.send\n\n  // Decode the response into Gleam data\n  let assert Ok(items) = sturnidae.get_feed_items_response(response)\n}\n```\n\nFurther documentation can be found at &lt;https://hexdocs.pm/sturnidae&gt;.\n","url":"index.html"},{"doc":"sturnidae","title":"CurrencyAndAmount","content":"pub type CurrencyAndAmount {\n  CurrencyAndAmount(currency: String, minor_units: Int)\n}\n\nCurrencyAndAmount(currency: String, minor_units: Int)\n\ncurrency\n&lt;p&gt;The currency of the amount. e.g. GBP.&lt;/p&gt;\n\nminor_units\n&lt;p&gt;The amount in minor units. e.g. pence in GBP.&lt;/p&gt;\n\nSynonyms:\nsturnidae.CurrencyAndAmount\nsturnidae CurrencyAndAmount","url":"sturnidae.html#CurrencyAndAmount"},{"doc":"sturnidae","title":"Direction","content":"pub type Direction {\n  In\n  Out\n}\n\nIn\n Inbound transactions are money coming into the account.\n\nOut\n Outbound transactions are money going out of the account.\n\nSynonyms:\nsturnidae.Direction\nsturnidae Direction","url":"sturnidae.html#Direction"},{"doc":"sturnidae","title":"FeedItem","content":"pub type FeedItem {\n  FeedItem(\n    feed_item_uid: String,\n    category_uid: String,\n    amount: CurrencyAndAmount,\n    source_amount: CurrencyAndAmount,\n    updated_at: String,\n    direction: Direction,\n    transaction_time: String,\n    source: String,\n    status: TransactionStatus,\n    counter_party_type: Option(String),\n    counter_party_uid: Option(String),\n    counter_party_name: String,\n    total_fees: Option(Int),\n    total_fee_amount: Option(CurrencyAndAmount),\n    reference: Option(String),\n    country: String,\n    spending_category: String,\n    user_note: Option(String),\n  )\n}\n An item from the account holders&#39;s transaction feed.\nFeedItem(\n  feed_item_uid: String,\n  category_uid: String,\n  amount: CurrencyAndAmount,\n  source_amount: CurrencyAndAmount,\n  updated_at: String,\n  direction: Direction,\n  transaction_time: String,\n  source: String,\n  status: TransactionStatus,\n  counter_party_type: Option(String),\n  counter_party_uid: Option(String),\n  counter_party_name: String,\n  total_fees: Option(Int),\n  total_fee_amount: Option(CurrencyAndAmount),\n  reference: Option(String),\n  country: String,\n  spending_category: String,\n  user_note: Option(String),\n)\n\nfeed_item_uid\n&lt;p&gt;Unique identifier for this item.&lt;/p&gt;\n\ncategory_uid\n&lt;p&gt;The category on which the transaction happened.&lt;/p&gt;\n\nupdated_at\n&lt;p&gt;The time the transaction was last updated at.&lt;/p&gt;\n\ndirection\n&lt;p&gt;The direction of the transaction.&lt;/p&gt;\n\ntransaction_time\n&lt;p&gt;The time of the transaction.&lt;/p&gt;\n\nsource\n&lt;p&gt;The source of the transaction. e.g. MASTER_CARD.&lt;/p&gt;\n\nstatus\n&lt;p&gt;The status of a transaction.&lt;/p&gt;\n\ncounter_party_type\n&lt;p&gt;The type of counter party for a transaction. e.g. MERCHANT&lt;/p&gt;\n\ncounter_party_uid\n&lt;p&gt;The unique identifier for the counter party. e.g. for MERCHANT this will\nbe the merchant uid, for PAYEE this will be the payee uid.&lt;/p&gt;\n\ncounter_party_name\n&lt;p&gt;The name of the counter party&lt;/p&gt;\n\ncountry\n&lt;p&gt;The country in which the transaction took place. ISO 3166-1 alpha-2\ncountry code.&lt;/p&gt;\n\nuser_note\n&lt;p&gt;The user-provided transaction note&lt;/p&gt;\n\nSynonyms:\nsturnidae.FeedItem\nsturnidae FeedItem","url":"sturnidae.html#FeedItem"},{"doc":"sturnidae","title":"StarlingApiError","content":"pub type StarlingApiError {\n  StarlingClientError(status_code: Int, messages: List(String))\n  StarlingServerError(status_code: Int, message: String)\n}\n\nStarlingClientError(status_code: Int, messages: List(String))\n\n\nStarlingServerError(status_code: Int, message: String)\n\n\nSynonyms:\nsturnidae.StarlingApiError\nsturnidae StarlingApiError","url":"sturnidae.html#StarlingApiError"},{"doc":"sturnidae","title":"StarlingApiResult","content":"pub type StarlingApiResult(t) =\n  Result(t, StarlingApiError)\n\n\nSynonyms:\nsturnidae.StarlingApiResult\nsturnidae StarlingApiResult","url":"sturnidae.html#StarlingApiResult"},{"doc":"sturnidae","title":"TransactionStatus","content":"pub type TransactionStatus {\n  Upcoming\n  Pending\n  Reversed\n  Settled\n  Declined\n  Refunded\n  Retrying\n  AccountCheck\n}\n\nUpcoming\n\n\nPending\n\n\nReversed\n\n\nSettled\n\n\nDeclined\n\n\nRefunded\n\n\nRetrying\n\n\nAccountCheck\n\n\nSynonyms:\nsturnidae.TransactionStatus\nsturnidae TransactionStatus","url":"sturnidae.html#TransactionStatus"},{"doc":"sturnidae","title":"v2","content":"pub const v2: String\n\nSynonyms:\nsturnidae.v2\nsturnidae v2","url":"sturnidae.html#v2"},{"doc":"sturnidae","title":"decode_feed_item","content":"pub fn decode_feed_item(\n  d: Dynamic,\n) -&gt; Result(FeedItem, List(DecodeError))\n\nSynonyms:\nsturnidae.decode_feed_item\nsturnidae decode_feed_item","url":"sturnidae.html#decode_feed_item"},{"doc":"sturnidae","title":"direction_to_string","content":"pub fn direction_to_string(direction: Direction) -&gt; String\n\nSynonyms:\nsturnidae.direction_to_string\nsturnidae direction_to_string","url":"sturnidae.html#direction_to_string"},{"doc":"sturnidae","title":"get_feed_items_request","content":"pub fn get_feed_items_request(\n  pat pat: String,\n  account_uid account: String,\n  category_uid category: String,\n  changes_since limit: String,\n) -&gt; Request(String)\n Create a request for the\n `/api/v2/feed/account/{accountUid}/category/{categoryUid}` endpoint.\n\n 🔒 Security: Requires the transaction:read OAuth scope\n\n Categories are subdivisions of an account. The default category holds the\n main balance and transactions. Savings goals and spending spaces are\n examples of other categories. You can use `/api/v2/accounts` to get the\n default category UID for an account.\n\nSynonyms:\nsturnidae.get_feed_items_request\nsturnidae get_feed_items_request","url":"sturnidae.html#get_feed_items_request"},{"doc":"sturnidae","title":"get_feed_items_response","content":"pub fn get_feed_items_response(\n  response: Response(String),\n) -&gt; Result(List(FeedItem), StarlingApiError)\n Decode a response from the\n `/api/v2/feed/account/{accountUid}/category/{categoryUid}` endpoint.\n\n See the `get_feed_items_request` function for creating a request to this endpoint.\n\nSynonyms:\nsturnidae.get_feed_items_response\nsturnidae get_feed_items_response","url":"sturnidae.html#get_feed_items_response"},{"doc":"sturnidae","title":"string_to_transaction_status","content":"pub fn string_to_transaction_status(\n  status: String,\n) -&gt; Result(TransactionStatus, Nil)\n\nSynonyms:\nsturnidae.string_to_transaction_status\nsturnidae string_to_transaction_status","url":"sturnidae.html#string_to_transaction_status"},{"doc":"sturnidae","title":"transaction_status_to_string","content":"pub fn transaction_status_to_string(\n  status: TransactionStatus,\n) -&gt; String\n\nSynonyms:\nsturnidae.transaction_status_to_string\nsturnidae transaction_status_to_string","url":"sturnidae.html#transaction_status_to_string"},{"doc":"sturnidae","title":"sturnidae","content":"","url":"sturnidae.html"}]);